-- ChangeManureSpreaderStateEvent
--
-- @ Autor  Tobias F. (John Deere 6930)
-- @ web http://www.vertexdezign.net/
-- @ Last Edit  27/02/2014

ChangeManureSpreaderStateEvent = {};
ChangeManureSpreaderStateEvent_mt = Class(ChangeManureSpreaderStateEvent, Event);

InitEventClass(ChangeManureSpreaderStateEvent, "ChangeManureSpreaderStateEvent");

function ChangeManureSpreaderStateEvent:emptyNew()
    local self = Event:new(ChangeManureSpreaderStateEvent_mt);
    self.className = "ChangeManureSpreaderStateEvent";
    return self;
end;

function ChangeManureSpreaderStateEvent:new(object, newstate)
    local self = ChangeManureSpreaderStateEvent:emptyNew()
    self.object = object;
	self.state = newstate;
    return self;
end;

function ChangeManureSpreaderStateEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.state = streamReadBool(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;

function ChangeManureSpreaderStateEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.state);
end;

function ChangeManureSpreaderStateEvent:run(connection)
	self.object:changeManureSpreaderState(self.state, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(ChangeManureSpreaderStateEvent:new(self.object, self.state), nil, connection, self.object);
    end;
end;

function ChangeManureSpreaderStateEvent.sendEvent(object, newstate, noEventSend)
	if object.state ~= newstate then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(ChangeManureSpreaderStateEvent:new(object, newstate), nil, nil, object);
			else
				g_client:getServerConnection():sendEvent(ChangeManureSpreaderStateEvent:new(object, newstate));
			end;
		end;
	end;
end;

